# PnoteClient

아래아 한글으로 작성된 프라이빗 노트의 노트 파일(이하 pnote 파일)을 json포맷으로 변환하여 저장합니다.

## Installation

Bundler를 사용할 경우 Gemfile에 다음 줄을 추가합니다.

```ruby
gem 'pnote_client', git: 'git@github.com:PrivateCoach/pnote_client.git'
```

그리고 다음 명령을 실행합니다.

    $ bundle

혹은 다음 명령으로 직접 젬을 설치할 수 있습니다.

```bash
git clone git@github.com:PrivateCoach/pnote_client.git
cd ./pnote_client
gem build pnote_client.gemspec
gem install pnote_client-[version].gem
```

## Usage

### Pnote to JSON

hml로 저장된 pnote 파일을 json 파일로 저장시키는 기능입니다.

```bash
$ pnote_to_json -f [input file(.hml)] -o [output file]
```

예를 들어 다음과 같이 사용할 수 있습니다.

```bash
$ pnote_to_json -f ./subject_1.hml -o ./subject_1.json
```

이 기능은 아래아 한글의 `스타일`을 사용하여 문단을 구분하기 때문에
입력으로 주어진 pnote에서 사용된 스타일 정보가 필요합니다.
기본으로 사용하는 스타일 정보는 다음과 같습니다.


1. 단원
2. 개념군
3. 개념
4. 개념 본문
5. 예제 문제
6. 예제(그림, 표, 박스, 글)
7. 예제 정답
8. 예제 정답 해설
9. 문제
10. 문제(그림, 표, 박스, 글)
11. 문제 정답
12. 문제 정답 해설
13. 각주(선생님한테 과외받기)
14. 보기
15. 꿀팁

설정 파일을 통해 스타일 정보를 수정할 수 있습니다.
설정 파일은 json 포맷으로 작성되고, `-c` 옵션을 통해 지정할 수 있습니다.
예를 들면 다음과 같습니다.

```bash
$ pnote_to_json -f [input] -o [output] -c ./config.json
```

`config.json` 파일의 예시는 다음과 같습니다. 키 값은 그대로 두고 스타일 문자열 부분만 변경하면 됩니다.

```json
{
  "hml_pnote_styles": {
    "chapter": "단원",
    "sub_chapter_title": "개념군",
    "concept_title": "개념",
    "concept_content": "개념 본문",
    "exercise_question": "예제 문제",
    "exercise_continuous_question": "예제(그림, 표, 박스, 글)",
    "exercise_answer": "예제 정답",
    "exercise_explaination": "예제 정답 해설",
    "practice_question": "문제",
    "practice_continuous_question": "문제(그림, 표, 박스, 글)",
    "practice_answer": "문제 정답",
    "practice_explaination": "문제 정답 해설",
    "practice_teacher_comment": "각주(선생님한테 과외받기)",
    "choice": "보기",
    "tip_content": "꿀팁"
  }
}
```

## License

[MIT License](http://opensource.org/licenses/MIT)

